/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DCFRIENDOBJECT_H
#define DCFRIENDOBJECT_H

#include <QString>
#include <QMap>

// for away mode
#include <dclib/core/types.h>

class QTreeWidgetItem;

class DCFriendObject {
public:

    /** construtor */
    DCFriendObject() {
        m_pItem = 0;
        m_eAwayMode = euamOFFLINE;
        m_bAutoSec = false;
        m_bSendImage = false;
        m_bPermSlot = false;
        m_bIgnore = false;
    };

    /** destructor */
    ~DCFriendObject() {
    };

    QTreeWidgetItem * m_pItem;

    /** */
    QString m_sName;
    /** */
    QString m_sDescription;
    /** */
    QString m_sHubName;
    /** */
    QString m_sHubHost;
    /** */
    QString m_sImageFileName;
    /** */
    eUserAwayMode m_eAwayMode;
    /** */
    bool m_bAutoSec;
    /** */
    bool m_bSendImage;
    /** If true, grant this user a permanent slot */
    bool m_bPermSlot;
    /** If true, ignore main chat lines from this user */
    bool m_bIgnore;
};

typedef QMap<QString, DCFriendObject*> FriendMap;

#endif // DCFRIENDOBJECT_H
